/*
 * ping.c
 */


#include<stdio.h>
#include<stdlib.h>
#include<ctype.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include<share/icmp.h>
#include<share/ip.h>


typedef struct{
	int seqnum;		/* ֹ档 */
}PING_DATA;


/*
 * Print usage.
 */
void usage()
{
	printf("usage: ping host\n");
}


/*
 * parameters : IP string,ip address buffer
 * return : 0 or error=-1
 */
static int cnvIpToBin(char *ip,uchar *sabuf)
{
	uchar tmp;
	int i,j;


	for(i=0;i<4;++i)
	{
		tmp=0;
		for(j=0;j<3;++j)
		{
			if(isdigit(*ip)==0)break;
			tmp*=10;
			tmp+=*ip++-'0';
		}
		sabuf[i]=tmp;

		if(*ip!='.')break;
		++ip;
	}
	if((i!=3)||((isspace(*ip))||(*ip!='\0')))return -1;

	return 0;
}


/*
 * parameters : ICMP_HEADER address,ICMP_HEADER structure size
 *
 */
static void mkIcmp(ICMP_HEADER *head,int size)
{
	head->type=ICMP_TYPE_ECHOREQ;
	head->code=0;
	head->chksum=0;
	head->chksum=calcSum((uint*)head,size);
}


int main(int argc,char *argv[])
{
	enum{
		IP_DATA_SIZE=sizeof(IP_HEADER)+sizeof(ICMP_HEADER)+sizeof(PING_DATA),
		ICMP_DATA_SIZE=sizeof(ICMP_HEADER)+sizeof(PING_DATA),
	};

	char buf[IP_DATA_SIZE];
	char saddr[sizeof(struct sockaddr)+4];
	char raddr[sizeof(struct sockaddr)+4];
	int sd;
	ICMP_HEADER *volatile head;
	PING_DATA *data;
	struct sockaddr *sa,*ra;
	socklen_t len;
	int i;


	/* IPɥ쥹ꡣ */
	if(argc==1)
	{
		printf("Arguments is few!\n");
		usage();
		return 0;
	}
	sa=(struct sockaddr*)saddr;
	if(cnvIpToBin(argv[1],sa->sa_data)==-1)
	{
		printf("IP address is not correct!\n");
		usage();
		return 0;
	}
	sa->sa_family=AF_INET;

	/* åȤγΩ */
	if((sd=socket(AF_INET,SOCK_RAW,IPPROTO_ICMP))<0)
	{
		perror("Error socket()");
		return 0;
	}

	/* ǡ */
	ra=(struct sockaddr*)raddr;
	for(i=1;i<=5;++i)
	{

		head=(ICMP_HEADER*)buf;
		data=(PING_DATA*)head->data;

		/* Set data. */
		data->seqnum=i;

		/* Make icmp data. */
		mkIcmp(head,ICMP_DATA_SIZE);

		/* Send to network. */
		if(sendto(sd,head,ICMP_DATA_SIZE,0,sa,sizeof(saddr))==-1)
		{
			perror("Error sendto()");
			break;
		}

		/* Receive ICMP data. */
		len=sizeof(raddr);
		if(recvfrom(sd,buf,IP_DATA_SIZE,0,ra,&len)==-1)
		{
			perror("Error recvfrom()");
			break;
		}
		head=(ICMP_HEADER*)((IP_HEADER*)buf)->data;
		data=(PING_DATA*)head->data;
		printf("Reply from %d.%d.%d.%d sequence number=%d\n",
			(uchar)ra->sa_data[0],(uchar)ra->sa_data[1],(uchar)ra->sa_data[2],(uchar)ra->sa_data[3],data->seqnum);

		sleep(1);
	}

	return 0;
}
